Coin: SbVec3s Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SbVec3s Class Reference
Base Classes

The SbVec3s class is a 3 dimensional vector with short integer coordinates. More...

`#include <Inventor/SbVec3s.h>`

## Public Member Functions
| SbVec3s (void)
| SbVec3s (const short v[3])
| SbVec3s (short x, short y, short z)
| SbVec3s (const SbVec3us &v)
| SbVec3s (const SbVec3b &v)
| SbVec3s (const SbVec3i32 &v)
| SbVec3s (const SbVec3f &v)
| SbVec3s (const SbVec3d &v)
SbVec3s & | setValue (const short v[3])
SbVec3s & | setValue (short x, short y, short z)
SbVec3s & | setValue (const SbVec3us &v)
SbVec3s & | setValue (const SbVec3b &v)
SbVec3s & | setValue (const SbVec3i32 &v)
SbVec3s & | setValue (const SbVec3f &v)
SbVec3s & | setValue (const SbVec3d &v)
const short * | getValue (void) const
void | getValue (short &x, short &y, short &z) const
short & | operator[] (int i)
const short & | operator[] (int i) const
int32_t | dot (const SbVec3s &v) const
void | negate (void)
SbVec3s & | operator*= (int d)
SbVec3s & | operator*= (double d)
SbVec3s & | operator/= (int d)
SbVec3s & | operator/= (double d)
SbVec3s & | operator+= (const SbVec3s &v)
SbVec3s & | operator-= (const SbVec3s &v)
SbVec3s | operator- (void) const
SbString | toString () const
SbBool | fromString (const SbString &str)
void | print (FILE *fp) const

## Protected Attributes
short | vec [3]

## Related Symbols
(Note that these are not member symbols.)
SbVec3s | operator* (const SbVec3s &v, int d)
SbVec3s | operator* (const SbVec3s &v, double d)
SbVec3s | operator* (int d, const SbVec3s &v)
SbVec3s | operator* (double d, const SbVec3s &v)
SbVec3s | operator/ (const SbVec3s &v, int d)
SbVec3s | operator/ (const SbVec3s &v, double d)
SbVec3s | operator+ (const SbVec3s &v1, const SbVec3s &v2)
SbVec3s | operator- (const SbVec3s &v1, const SbVec3s &v2)
int | operator== (const SbVec3s &v1, const SbVec3s &v2)
int | operator!= (const SbVec3s &v1, const SbVec3s &v2)

## Detailed Description

The SbVec3s class is a 3 dimensional vector with short integer coordinates.

This vector class provides storage for a 3 dimensional vector as well as simple integer arithmetic operations.

Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

See also
  SbVec2s, SbVec2f, SbVec2d, SbVec3f, SbVec3d, SbVec4f, SbVec4d.

Since
  Coin 2.0
  TGS Inventor ?.?

## Constructor & Destructor Documentation

## ◆ SbVec3s() [1/8]

SbVec3s::SbVec3s | ( | void |  | ) |
| inline

The default constructor does nothing. The vector coordinates will be uninitialized until you do a setValue() call.

## ◆ SbVec3s() [2/8]

SbVec3s::SbVec3s | ( | const short | v[3] | ) |
| inline

Constructs an SbVec3s instance with initial values from v.

## ◆ SbVec3s() [3/8]

SbVec3s::SbVec3s | ( | short | x,
|  | short | y,
|  | short | z )
| inline

Constructs an SbVec3s instance with the initial vector endpoint set to <x,y,z>.

## ◆ SbVec3s() [4/8]

SbVec3s::SbVec3s | ( | const SbVec3us & | v | ) |
| inlineexplicit

Since
  Coin 2.5

## ◆ SbVec3s() [5/8]

SbVec3s::SbVec3s | ( | const SbVec3b & | v | ) |
| inlineexplicit

Since
  Coin 2.5

## ◆ SbVec3s() [6/8]

SbVec3s::SbVec3s | ( | const SbVec3i32 & | v | ) |
| inlineexplicit

Since
  Coin 2.5

## ◆ SbVec3s() [7/8]

SbVec3s::SbVec3s | ( | const SbVec3f & | v | ) |
| inlineexplicit

Since
  Coin 2.5

## ◆ SbVec3s() [8/8]

SbVec3s::SbVec3s | ( | const SbVec3d & | v | ) |
| inlineexplicit

Since
  Coin 2.5

## Member Function Documentation

## ◆ setValue() [1/7]

SbVec3s & SbVec3s::setValue | ( | const short | v[3] | ) |
| inline

Set new coordinates for the vector from v. Returns reference to self.

See also
  getValue().

## ◆ setValue() [2/7]

SbVec3s & SbVec3s::setValue | ( | short | x,
|  | short | y,
|  | short | z )
| inline

Set new coordinates for the vector. Returns reference to self.

See also
  getValue().

## ◆ setValue() [3/7]

SbVec3s & SbVec3s::setValue | ( | const SbVec3us & | v | ) |

Sets the value from an SbVec3us instance.

Since
  Coin 2.5

## ◆ setValue() [4/7]

SbVec3s & SbVec3s::setValue | ( | const SbVec3b & | v | ) |

Sets the value from an SbVec3b instance.

Since
  Coin 2.5

## ◆ setValue() [5/7]

SbVec3s & SbVec3s::setValue | ( | const SbVec3i32 & | v | ) |

Sets the value from an SbVec3i32 instance.

Since
  Coin 2.5

## ◆ setValue() [6/7]

SbVec3s & SbVec3s::setValue | ( | const SbVec3f & | v | ) |

Sets the value from an SbVec3f instance.

Since
  Coin 2.5

## ◆ setValue() [7/7]

SbVec3s & SbVec3s::setValue | ( | const SbVec3d & | v | ) |

Sets the value from an SbVec3d instance.

Since
  Coin 2.5

## ◆ getValue() [1/2]

const short * SbVec3s::getValue | ( | void |  | ) | const
| inline

Returns a pointer to an array of three shorts containing the x, y and z coordinates of the vector.

See also
  setValue().

## ◆ getValue() [2/2]

void SbVec3s::getValue | ( | short & | x,
|  | short & | y,
|  | short & | z ) const
| inline

Returns the x, y and z coordinates of the vector.

See also
  setValue().

## ◆ operator[]() [1/2]

short & SbVec3s::operator[] | ( | int | i | ) |
| inline

Index operator. Returns modifiable x, y or z coordinate of vector.

See also
  getValue() and setValue().

## ◆ operator[]() [2/2]

const short & SbVec3s::operator[] | ( | int | i | ) | const
| inline

Index operator. Returns x, y or z coordinate of vector.

See also
  getValue() and setValue().

## ◆ dot()

int32_t SbVec3s::dot | ( | const SbVec3s & | v | ) | const
| inline

Calculates and returns the result of taking the dot product of this vector and v.

## ◆ negate()

void SbVec3s::negate | ( | void |  | ) |
| inline

Negate the vector (i.e. point it in the opposite direction).

## ◆ operator*=() [1/2]

SbVec3s & SbVec3s::operator*= | ( | int | d | ) |
| inline

Multiply components of vector with value d. Returns reference to self.

## ◆ operator*=() [2/2]

SbVec3s & SbVec3s::operator*= | ( | double | d | ) |

Multiply components of vector with value d. Returns reference to self.

## ◆ operator/=() [1/2]

SbVec3s & SbVec3s::operator/= | ( | int | d | ) |
| inline

Divides components of vector with value d. Returns reference to self.

## ◆ operator/=() [2/2]

SbVec3s & SbVec3s::operator/= | ( | double | d | ) |
| inline

Divides components of vector with value d. Returns reference to self.

## ◆ operator+=()

SbVec3s & SbVec3s::operator+= | ( | const SbVec3s & | v | ) |
| inline

Adds this vector and vector v. Returns reference to self.

## ◆ operator-=()

SbVec3s & SbVec3s::operator-= | ( | const SbVec3s & | v | ) |
| inline

Subtracts vector v from this vector. Returns reference to self.

## ◆ operator-()

SbVec3s SbVec3s::operator- | ( | void |  | ) | const
| inline

Non-destructive negation operator. Returns a new SbVec3s instance which points in the opposite direction of this vector.

See also
  negate().

## ◆ toString()

SbString SbVec3s::toString | ( |  | ) | const

Return a string representation of this object

## ◆ fromString()

SbBool SbVec3s::fromString | ( | const SbString & | str | ) |

Convert from a string representation, return whether this is a valid conversion

## ◆ print()

void SbVec3s::print | ( | FILE * | fp | ) | const

Dump the state of this object to the fp file stream. Only works in debug version of library, method does nothing in an optimized build.

## Friends And Related Symbol Documentation

## ◆ operator*() [1/4]

SbVec3s operator* | ( | const SbVec3s & | v,
|  | int | d )
| related

Returns an SbVec3s instance which is the components of vector v multiplied with d.

## ◆ operator*() [2/4]

SbVec3s operator* | ( | const SbVec3s & | v,
|  | double | d )
| related

Returns an SbVec3s instance which is the components of vector v multiplied with d.

## ◆ operator*() [3/4]

SbVec3s operator* | ( | int | d,
|  | const SbVec3s & | v )
| related

Returns an SbVec3s instance which is the components of vector v multiplied with d.

## ◆ operator*() [4/4]

SbVec3s operator* | ( | double | d,
|  | const SbVec3s & | v )
| related

Returns an SbVec3s instance which is the components of vector v multiplied with d.

## ◆ operator/() [1/2]

SbVec3s operator/ | ( | const SbVec3s & | v,
|  | int | d )
| related

Returns an SbVec3s instance which is the components of vector v divided on the scalar factor d.

## ◆ operator/() [2/2]

SbVec3s operator/ | ( | const SbVec3s & | v,
|  | double | d )
| related

Returns an SbVec3s instance which is the components of vector v divided on d.

## ◆ operator+()

SbVec3s operator+ | ( | const SbVec3s & | v1,
|  | const SbVec3s & | v2 )
| related

Returns an SbVec3s instance which is the sum of vectors v1 and v2.

## ◆ operator-()

SbVec3s operator- | ( | const SbVec3s & | v1,
|  | const SbVec3s & | v2 )
| related

Returns an SbVec3s instance which is vector v2 subtracted from vector v1.

## ◆ operator==()

int operator== | ( | const SbVec3s & | v1,
|  | const SbVec3s & | v2 )
| related

Returns 1 if v1 and v2 are exactly equal, 0 otherwise.

## ◆ operator!=()

int operator!= | ( | const SbVec3s & | v1,
|  | const SbVec3s & | v2 )
| related

Returns 1 if v1 and v2 are not equal, 0 if they are equal.

The documentation for this class was generated from the following files:

- SbVec3s.h
- SbVec3s.cpp